#include <stdio.h>
#include "getsys.h"

extern int errno;




/*
 * m a i n
 */
main(argc, argv)
  int  argc;
  char *argv[];
{
  register int i, j;

  for (i = 1; i < argc; i++)
    if (argv[i][j] == '-')
      for (j = 1; j < strlen(argv[i]); j++)
        switch (argv[i][j]) {
          case '?':
            usage();
            exit(1);

          default:
            usage();
            exit(_errmsg(1, "unknown option '%c'\n", argv[i][j]));
        }
    else {
      usage();
      exit(_errmsg(1, "no parameters recognized\n"));
    }
  
  printf("System global variables (OS-9/680x0 V2.3):\n");
  printf("------------------------------------------\n\n");

  printf("set to modsync code after coldstart ......... $%x\n", gs(D_ID , 2));
  printf("prevent sysproc from sleeping if 1 .......... $%x\n", gs(D_NoSleep, 2));
  printf("initialization module ptr ('init') .......... $%x\n", gs(D_Init , 4));
  printf("address of system tick routine .............. $%x\n", gs(D_Clock, 4));
  printf("number of ticks per second .................. %d\n", gs(D_TckSec, 2));
  printf("year ........................................ %d\n", gs(D_Year , 2));
  printf("month ....................................... %d\n", gs(D_Month, 1));
  printf("day ......................................... %d\n", gs(D_Day , 1));
  printf("compatability flags ......................... $%x\n", gs(D_Compat, 1));
  printf("0 = no FPU, 1 = 68881, 2 = 68882 ............ %d\n", gs(D_68881, 1));
  printf("julian day number ........................... %d\n", gs(D_Julian, 4));
  printf("system time seconds left until midnight ..... %d\n", gs(D_Second, 4));
  printf("IRQ flag .................................... $%x\n", gs(D_IRQFlag, 1));
  printf("number of unknown IRQs ...................... %d\n", gs(D_UnkIRQ, 1));
  printf("module directory (start ptr) ................ $%x\n", gs(D_ModDir, 4));
  printf("module directory (start end) ................ $%x\n", gs(D_ModDir2, 4));
  printf("Process Descriptor Block Table ptr .......... $%x\n", gs(D_PrcDBT, 4));
  printf("Path Descriptor Block Table ptr ............. $%x\n", gs(D_PthDBT, 4));
  printf("Current Process descriptor ptr .............. $%x\n", gs(D_Proc , 4));
  printf("System Process Descriptor ptr ............... $%x\n", gs(D_SysPrc, 4));
  printf("ever-increment system tick .................. %d\n", gs(D_Ticks, 4));
  printf("Process whose context is in FPU registers ... $%x\n", gs(D_FProc, 4));
  printf("System state bus trap panic abort sp ........ $%x\n", gs(D_AbtStk, 4));
  printf("System IRQ stack ptr ........................ $%x\n", gs(D_SysStk, 4));
  printf("Bootstrap ROM execution entry point ......... $%x\n", gs(D_SysROM, 4));
  printf("Exception Jump Table ptr .................... $%x\n", gs(D_ExcJmp, 4));
  printf("total RAM found by BootROM at startup ....... $%x\n", gs(D_TotRAM, 4));
  printf("process minimum allocatable block size ...... %d\n", gs(D_MinBlk, 4));
  printf("system free memory list head start .......... $%x\n", gs(D_FreMem, 4));
  printf("system free memory list head end ............ $%x\n", gs(D_FreMem2, 4));
  printf("system minimum allocatable block size ....... %d\n", gs(D_BlkSiz, 4));
  printf("I/O Device Table ptr ........................ $%x\n", gs(D_DevTbl, 4));
  printf("System Service dispatch table ptr ........... $%x\n", gs(D_SysDis, 4));
  printf("User Service dispatch table ptr ............. $%x\n", gs(D_UsrDis, 4));
  printf("Active process queue head start ............. $%x\n", gs(D_ActivQ, 4));
  printf("Active process queue head end ............... $%x\n", gs(D_ActivQ2, 4));
  printf("Sleeping process queue head start ........... $%x\n", gs(D_SleepQ, 4));
  printf("Sleeping process queue head end ............. $%x\n", gs(D_SleepQ2, 4));
  printf("Sleeping process queue head start ........... $%x\n", gs(D_WaitQ, 4));
  printf("Sleeping process queue head end ............. $%x\n", gs(D_WaitQ2, 4));
  printf("Active queue age ............................ $%x\n", gs(D_ActAge, 4));
  printf("MPU type (68000/10/20/30/70) ................ %d\n", gs(D_MPUTyp, 4));
  printf("ptr to system Event table start ............. $%x\n", gs(D_EvTbl, 4));
  printf("ptr to system Event table end ............... $%x\n", gs(D_EvTbl2, 4));
  printf("next (incrementing) event ID number ......... %d\n", gs(D_EvID , 4));
  printf("ptr to SPU global variables ................. $%x\n", gs(D_SPUMem, 4));
  printf("highest address found during startup ........ $%x\n", gs(D_AddrLim, 4));
  printf("size of a process descriptor ................ %d\n", gs(D_ProcSz, 2));
  printf("I/O AutoVector 0 Polling table heads ........ $%x\n", gs(D_PolTbl, 4));
  printf("I/O AutoVector 1 Polling table heads ........ $%x\n", gs(D_PolTbl2, 4));
  printf("I/O AutoVector 2 Polling table heads ........ $%x\n", gs(D_PolTbl3, 4));
  printf("I/O AutoVector 3 Polling table heads ........ $%x\n", gs(D_PolTbl4, 4));
  printf("I/O AutoVector 4 Polling table heads ........ $%x\n", gs(D_PolTbl5, 4));
  printf("I/O AutoVector 5 Polling table heads ........ $%x\n", gs(D_PolTbl6, 4));
  printf("I/O AutoVector 6 Polling table heads ........ $%x\n", gs(D_PolTbl7, 4));
  printf("I/O AutoVector 7 Polling table heads ........ $%x\n", gs(D_PolTbl8, 4));
  printf("head of free mem color node list start ...... $%x\n", gs(D_FreeMem, 4));
  printf("head of free mem color node list end ........ $%x\n", gs(D_FreeMem2, 4));
  printf("interprocessor identification number ........ %d\n", gs(D_IPID , 2));
  printf("ptr to array of cpu descriptor list heads ... $%x\n", gs(D_CPUs , 4));
  printf("head of inter-processor command queue start . $%x\n", gs(D_IPCmd, 4));
  printf("head of inter-processor command queue end ... $%x\n", gs(D_IPCmd2, 4));
  printf("68020/68030 CACR mode ....................... $%x\n", gs(D_CachMode, 4));
  printf("instruction cache disable depth ............. %d\n", gs(D_DisInst, 4));
  printf("data cache disable depth .................... %d\n", gs(D_DisData, 4));
  printf("ptr to clock tick thief's static storage .... $%x\n", gs(D_ClkMem, 4));
  printf("current tick ................................ %d\n", gs(D_Tick , 2));
  printf("ticks per slice ............................. %d\n", gs(D_TSlice, 2));
  printf("current time slice remaining (ticks) ........ %d\n", gs(D_Slice, 2));
  printf("ticks to elapse before sys proc is awakened . %d\n", gs(D_Elapse, 4));
  printf("system Thread queue head start .............. $%x\n", gs(D_Thread, 4));
  printf("system Thread queue head end ................ $%x\n", gs(D_Thread2, 4));
  printf("system timed alarm threads start ............ $%x\n", gs(D_AlarTh, 4));
  printf("system timed alarm threads end .............. $%x\n", gs(D_AlarTh2, 4));
  printf("System IRQ stack low bound .................. $%x\n", gs(D_SStkLm, 4));
  printf("Number of actively forked processes. ........ %d\n", gs(D_Forks, 4));
  printf("Ram found during bootrom search ............. $%x\n", gs(D_BootRAM, 4));
  printf("system minimum process priority ............. %d\n", gs(D_MinPty, 2));
  printf("system priority maximum age limit ........... %d\n", gs(D_MaxAge, 2));
  printf("process ID of process that has siezed cpu ... %d\n", gs(D_Sieze, 2));
  printf("estimate of sysglob, process, and module defs $%x\n", gs(D_Cigar, 4));
  printf("former min memory address allocatable ....... $%x\n", gs(D_MMinLim, 4));
  printf("former max memory address allocatable (+1) .. $%x\n", gs(D_MMaxLim, 4));
  printf("system debugger entry pt address ............ $%x\n", gs(D_SysDbg, 4));
  printf("system debugger memory ptr .................. $%x\n", gs(D_DbgMem, 4));
  printf("system debugger active flag ................. $%x\n", gs(D_DbgFlg, 1));
  printf("disk cache buffer head ...................... $%x\n", gs(D_Cache, 4));
}


/*
 * g s
 */
gs(glob, size)
  short glob;
  int   size;
{
  char  ch;
  short sh;
  long  lg, ret;
  
  ret = (long) _getsys(glob, size);

  if(ret == -1) {
    exit(_errmsg(errno, "can't get system variable %d\n", glob));
    exit(errno);
  }

  return(ret);
}


/*
 * u s a g e
 */
usage()
{
  fputs("Syntax: getsys [<opts>]\n", stderr);
  fputs("Function: display system global variables\n", stderr);
  fputs("Options:  none\n", stderr);
}

